Hover Style: SpreadJS supports the following hover style customizations:
the color and transparency
Border: color, transparency, width, dash style
Symbol: color, transparency
Symbol Border: color, transparency, width, dash style
You can customize the hover style using the following code:
Hover Animation: Hover animation can help to improve the user experience when interacting with the chart. You can use the useAnimation() API to set whether or not to apply animation to the chart.
var spread;
window.onload = function () {
spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 1 });
initSpread(spread);
initEvent(spread);
//readSetting(new GC.Spread.Sheets.CellTypes.CheckBoxList());
};
function initSpread(spread) {
var sheet = spread.getSheet(0);
sheet.suspendPaint();
var dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
var chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 494, 0, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({text: "HoverStyle with markers"});
var seriesItem = chart.series().get(0);
seriesItem.symbol.size = 20;
chart.series().set(0, seriesItem);
var hoverStyle = {
color: "orange",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 3,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
},
symbolStyle: {
color: "yellow",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: 'rgb(0, 0, 255)',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
}
};
chart.hoverStyle(hoverStyle);
var chart2 = sheet.charts.add('Chart2', GC.Spread.Sheets.Charts.ChartType.columnClustered, 0, 100, 494, 275, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart2.title({text: "Default HoverStyle"});
var chart3 = sheet.charts.add('Chart3', GC.Spread.Sheets.Charts.ChartType.pie, 494, 270, 480, 270, 'A1:H2');
chart3.title({text: "HoverStyle with Animation"});
chart3.useAnimation(true);
var hoverStyle3 = {
color: "orange",
transparency: 0.6,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
};
chart3.hoverStyle(hoverStyle3);
sheet.resumePaint();
};
function initEvent(spread) {
spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, function () {
var sheet = spread.getActiveSheet();
var chart = getActiveChart(sheet);
if (chart) {
readSetting(chart);
}
});
_getElementById("apply").addEventListener('click', function () {
applySetting();
});
};
function readSetting(chart) {
_getElementById("useAnimation").checked = chart.useAnimation();
var hoverStyle = chart.hoverStyle();
if (!hoverStyle) {
return;
}
_getElementById("color").value = hoverStyle.color || "";
_getElementById("transparency").value = hoverStyle.transparency;
_getElementById("border-color").value = hoverStyle.borderStyle.color || "";
_getElementById("border-width").value = hoverStyle.borderStyle.width || 0;
_getElementById("border-transparency").value = hoverStyle.borderStyle.transparency;
_getElementById("border-dashStyle").value = hoverStyle.borderStyle.dashStyle;
_getElementById("symbol-color").value = hoverStyle.symbolStyle.color || "";
_getElementById("symbol-transparency").value = hoverStyle.symbolStyle.transparency;
_getElementById("symbol-border-color").value = hoverStyle.symbolStyle.borderStyle.color || "";
_getElementById("symbol-border-width").value = hoverStyle.symbolStyle.borderStyle.width || 0;
_getElementById("symbol-border-transparency").value = hoverStyle.symbolStyle.borderStyle.transparency;
_getElementById("symbol-border-dashStyle").value = hoverStyle.symbolStyle.borderStyle.dashStyle;
}
function applySetting() {
var sheet = spread.getActiveSheet();
var chart = getActiveChart(sheet);
if (!chart) {
return;
}
chart.useAnimation( _geBoolean("useAnimation"));
var hoverStyle = {
color: _getText("color"),
transparency: _getFloat("transparency"),
borderStyle:{
color: _getText("border-color"),
width: _getValue("border-width"),
transparency: _getFloat("border-transparency"),
dashStyle: _getValue("border-dashStyle"),
},
symbolStyle:{
color: _getText("symbol-color"),
transparency: _getFloat("symbol-transparency"),
borderStyle:{
color: _getText("symbol-border-color"),
width: _getValue("symbol-border-width"),
transparency: _getFloat("symbol-border-transparency"),
dashStyle: _getValue("symbol-border-dashStyle"),
}
}
}
chart.hoverStyle(hoverStyle);
}
function getActiveChart(sheet) {
var activeChart = null;
sheet.charts.all().forEach(function (chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
function _getElementById(id) {
return document.getElementById(id);
}
function _geBoolean(id) {
return _getElementById(id).checked;
}
function _getFloat(id) {
return parseFloat(_getElementById(id).value);
}
function _getValue(id) {
return parseInt(_getElementById(id).value);
}
function _getText(id) {
return _getElementById(id).value;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-charts/dist/gc.spread.sheets.charts.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
<label for="useAnimation">useAnimation</label>
<input type="checkbox" id="useAnimation" checked />
</div>
<div class="option-row" id="">
<label for="color">Color:</label>
<input type="text" id="color" value="#FF0000" />
</div>
<div class="option-row" id="">
<label for="transparency">Transparency:</label>
<input type="number" id="transparency" step="0.1" min="0" max="1" value="0.7" />
</div>
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" value="#00FF00" />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" value="1" />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" value="1" />
</div>
<div class="option-row" id="">
<label for="border-dashStyle">Border DashStyle:</label>
<select id="border-dashStyle">
<option value="0" selected="selected">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<hr>
<div class="option-row" id="">
<label for="symbol-color">Symbol Color:</label>
<input type="text" id="symbol-color" value="orange" />
</div>
<div class="option-row" id="">
<label for="symbol-transparency">Symbol Transparency:</label>
<input type="number" id="symbol-transparency" step="0.1" min="0" max="1" value="0.7" />
</div>
<div class="option-row" id="">
<label for="symbol-border-color">Symbol Border Color:</label>
<input type="text" id="symbol-border-color" value="rgb(255,0,255)" />
</div>
<div class="option-row" id="">
<label for="symbol-border-width">Symbol Border Width:</label>
<input type="number" id="symbol-border-width" step="1" min="0" max="100" value="1" />
</div>
<div class="option-row" id="">
<label for="symbol-border-transparency">Symbol Border Transparency:</label>
<input type="number" id="symbol-border-transparency" step="0.1" min="0" max="1" value="0.7" />
</div>
<div class="option-row" id="">
<label for="symbol-border-dashStyle">Symbol Border DashStyle:</label>
<select id="symbol-border-dashStyle">
<option value="0" selected="selected">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" />
</div>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display:inline-block;
}
input{
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select{
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

Hover Style: SpreadJS supports the following hover style customizations:
the color and transparency
Border: color, transparency, width, dash style
Symbol: color, transparency
Symbol Border: color, transparency, width, dash style
You can customize the hover style using the following code:
Hover Animation: Hover animation can help to improve the user experience when interacting with the chart. You can use the useAnimation() API to set whether or not to apply animation to the chart.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet />
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label for="useAnimation">useAnimation</label>
<input type="checkbox" id="useAnimation" v-model="useAnimation" />
</div>
<div class="option-row" id="">
<label for="color">Color:</label>
<input type="text" id="color" v-model="color" />
</div>
<div class="option-row" id="">
<label for="transparency">Transparency:</label>
<input type="number" id="transparency" step="0.1" min="0" max="1" v-model="transparency" />
</div>
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" v-model="borderColor" />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" v-model="borderWidth" />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" v-model="borderTransparency" />
</div>
<div class="option-row" id="">
<label for="border-dashStyle">Border DashStyle:</label>
<select id="border-dashStyle" v-model="borderDashStyle">
<option value="0">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<hr>
<div class="option-row" id="">
<label for="symbol-color">Symbol Color:</label>
<input type="text" id="symbol-color" v-model="symbolColor" />
</div>
<div class="option-row" id="">
<label for="symbol-transparency">Symbol Transparency:</label>
<input type="number" id="symbol-transparency" step="0.1" min="0" max="1" v-model="symbolTransparency" />
</div>
<div class="option-row" id="">
<label for="symbol-border-color">Symbol Border Color:</label>
<input type="text" id="symbol-border-color" v-model="symbolBorderColor" />
</div>
<div class="option-row" id="">
<label for="symbol-border-width">Symbol Border Width:</label>
<input type="number" id="symbol-border-width" step="1" min="0" max="100" v-model="symbolBorderWidth" />
</div>
<div class="option-row" id="">
<label for="symbol-border-transparency">Symbol Border Transparency:</label>
<input type="number" id="symbol-border-transparency" step="0.1" min="0" max="1"
v-model="symbolBorderTransparency" />
</div>
<div class="option-row" id="">
<label for="symbol-border-dashStyle">Symbol Border DashStyle:</label>
<select id="symbol-border-dashStyle" v-model="symbolBorderDashStyle">
<option value="0">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" @click="applySetting" />
</div>
</div>
</div>
</template>
<script setup>
import { ref } from 'vue';
import '@mescius/spread-sheets-vue';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
const spread = ref(null);
const useAnimation = ref(true);
const color = ref('#FF0000');
const transparency = ref(0.7);
const borderColor = ref('#00FF00');
const borderWidth = ref(1);
const borderTransparency = ref(1);
const borderDashStyle = ref('0');
const symbolColor = ref('orange');
const symbolTransparency = ref(0.7);
const symbolBorderColor = ref('rgb(255,0,255)');
const symbolBorderWidth = ref(1);
const symbolBorderTransparency = ref(0.7);
const symbolBorderDashStyle = ref('0');
const initSpread = (spreadInstance) => {
spread.value = spreadInstance;
spreadInstance.setSheetCount(2);
const sheet = spreadInstance.getSheet(0);
sheet.suspendPaint();
const dataArray = [
['', 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
['2014', 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
['2015', 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
['2016', 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
['2017', 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246],
];
sheet.setArray(0, 0, dataArray);
const chart = sheet.charts.add(
'Chart1',
GC.Spread.Sheets.Charts.ChartType.lineMarkers,
494,
0,
480,
270,
'A1:D5',
GC.Spread.Sheets.Charts.RowCol.columns,
);
chart.title({
text: 'HoverStyle with markers',
});
const seriesItem = chart.series().get(0);
seriesItem.symbol.size = 20;
chart.series().set(0, seriesItem);
const hoverStyle = {
color: 'orange',
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 3,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash,
},
symbolStyle: {
color: 'yellow',
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: 'rgb(0, 0, 255)',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash,
},
},
};
chart.hoverStyle(hoverStyle);
const chart2 = sheet.charts.add(
'Chart2',
GC.Spread.Sheets.Charts.ChartType.columnClustered,
0,
100,
494,
275,
'A1:D5',
GC.Spread.Sheets.Charts.RowCol.columns,
);
chart2.title({
text: 'Default HoverStyle',
});
const chart3 = sheet.charts.add(
'Chart3',
GC.Spread.Sheets.Charts.ChartType.pie,
494,
270,
480,
270,
'A1:H2',
);
chart3.title({
text: 'HoverStyle with Animation',
});
chart3.useAnimation(true);
const hoverStyle3 = {
color: 'orange',
transparency: 0.6,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash,
},
};
chart3.hoverStyle(hoverStyle3);
initEvent(spreadInstance);
readSetting(chart);
sheet.resumePaint();
};
const initEvent = () => {
spread.value.bind(GC.Spread.Sheets.Events.FloatingElementSelected, () => {
const sheet = spread.value.getActiveSheet();
const chart = getActiveChart(sheet);
if (chart) {
readSetting(chart);
}
});
};
const readSetting = (chart) => {
const useAnimationValue = chart.useAnimation();
const hoverStyle = chart.hoverStyle();
if (!hoverStyle) return;
useAnimation.value = useAnimationValue;
color.value = hoverStyle.color;
transparency.value = hoverStyle.transparency;
borderColor.value = hoverStyle.borderStyle.color;
borderWidth.value = hoverStyle.borderStyle.width;
borderTransparency.value = hoverStyle.borderStyle.transparency;
borderDashStyle.value = hoverStyle.borderStyle.dashStyle;
symbolColor.value = hoverStyle.symbolStyle.color;
symbolTransparency.value = hoverStyle.symbolStyle.transparency;
symbolBorderColor.value = hoverStyle.symbolStyle.borderStyle.color;
symbolBorderWidth.value = hoverStyle.symbolStyle.borderStyle.width;
symbolBorderTransparency.value = hoverStyle.symbolStyle.borderStyle.transparency;
symbolBorderDashStyle.value = hoverStyle.symbolStyle.borderStyle.dashStyle;
};
const applySetting = () => {
const sheet = spread.value.getActiveSheet();
const chart = getActiveChart(sheet);
if (!chart) return;
chart.useAnimation(useAnimation.value);
const hoverStyle = {
color: color.value,
transparency: parseFloat(transparency.value),
borderStyle: {
color: borderColor.value,
width: parseInt(borderWidth.value, 10),
transparency: parseFloat(borderTransparency.value),
dashStyle: parseFloat(borderDashStyle.value),
},
symbolStyle: {
color: symbolColor.value,
transparency: parseFloat(symbolTransparency.value),
borderStyle: {
color: symbolBorderColor.value,
width: parseInt(symbolBorderWidth.value, 10),
transparency: parseFloat(symbolBorderTransparency.value),
dashStyle: parseFloat(symbolBorderDashStyle.value),
},
},
};
chart.hoverStyle(hoverStyle);
};
const getActiveChart = (sheet) => {
let activeChart = null;
sheet.charts.all().forEach((chart) => {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
};
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display: inline-block;
}
input {
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select {
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Hover Style: SpreadJS supports the following hover style customizations:
the color and transparency
Border: color, transparency, width, dash style
Symbol: color, transparency
Symbol Border: color, transparency, width, dash style
You can customize the hover style using the following code:
Hover Animation: Hover animation can help to improve the user experience when interacting with the chart. You can use the useAnimation() API to set whether or not to apply animation to the chart.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
function _getBoolean(e) {
return e.target.checked;
}
function _getFloat(e) {
return parseFloat(e.target.value);
}
function _getValue(e) {
return parseInt(e.target.value);
}
function _getText(e) {
return e.target.value;
}
let spread = null;
export function AppFunc() {
const [hoverInfo, setHoverInfo] = React.useState({
useAnimation: true,
color: "#FF0000",
transparency: 0.7,
borderColor: "#00FF00",
borderWidth: 1,
borderTransparency: 1,
borderDashStyle: "0",
symbolColor: "orange",
symbolTransparency: 0.7,
symbolBorderColor: "rgb(255,0,255)",
symbolBorderWidth: 1,
symbolBorderTransparency: 0.7,
symbolBorderDashStyle: "0"
});
const initSpread = (currSpread) => {
spread = currSpread;
spread.setSheetCount(2);
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
let chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 494, 0, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({ text: "HoverStyle with markers" });
let seriesItem = chart.series().get(0);
seriesItem.symbol.size = 20;
chart.series().set(0, seriesItem);
let hoverStyle = {
color: "orange",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 3,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
},
symbolStyle: {
color: "yellow",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: 'rgb(0, 0, 255)',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
}
};
chart.hoverStyle(hoverStyle);
let chart2 = sheet.charts.add('Chart2', GC.Spread.Sheets.Charts.ChartType.columnClustered, 0, 100, 494, 275, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart2.title({ text: "Default HoverStyle" });
let chart3 = sheet.charts.add('Chart3', GC.Spread.Sheets.Charts.ChartType.pie, 494, 270, 480, 270, 'A1:H2');
chart3.title({ text: "HoverStyle with Animation" });
chart3.useAnimation(true);
let hoverStyle3 = {
color: "orange",
transparency: 0.6,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
};
chart3.hoverStyle(hoverStyle3);
initEvent(spread);
readSetting(chart);
sheet.resumePaint();
};
const initEvent = () => {
spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, function () {
let sheet = spread.getActiveSheet();
let chart = getActiveChart(sheet);
if (chart) {
readSetting(chart);
}
});
};
const readSetting = (chart) => {
let useAnimation = chart.useAnimation();
let hoverStyle = chart.hoverStyle();
if (!hoverStyle) {
return;
}
setHoverInfo({
...hoverInfo,
useAnimation: useAnimation,
color: hoverStyle.color || "",
transparency: hoverStyle.transparency,
borderColor: hoverStyle.borderStyle.color || "",
borderWidth: hoverStyle.borderStyle.width || 0,
borderTransparency: hoverStyle.borderStyle.transparency,
borderDashStyle: hoverStyle.borderStyle.dashStyle,
symbolColor: hoverStyle.symbolStyle.color || "",
symbolTransparency: hoverStyle.symbolStyle.transparency,
symbolBorderColor: hoverStyle.symbolStyle.borderStyle.color || "",
symbolBorderWidth: hoverStyle.symbolStyle.borderStyle.width || 0,
symbolBorderTransparency: hoverStyle.symbolStyle.borderStyle.transparency,
symbolBorderDashStyle: hoverStyle.symbolStyle.borderStyle.dashStyle,
});
}
const applySetting = (setting) => {
let sheet = spread.getActiveSheet();
let chart = getActiveChart(sheet);
if (!chart) {
return;
}
chart.useAnimation(setting.useAnimation);
let hoverStyle = {
color: setting.color,
transparency: setting.transparency,
borderStyle: {
color: setting.borderColor,
width: setting.borderWidth,
transparency: setting.borderTransparency,
dashStyle: setting.borderDashStyle,
},
symbolStyle: {
color: setting.symbolColor,
transparency: setting.symbolTransparency,
borderStyle: {
color: setting.symbolBorderColor,
width: setting.symbolBorderWidth,
transparency: setting.symbolBorderTransparency,
dashStyle: setting.symbolBorderDashStyle,
}
}
}
chart.hoverStyle(hoverStyle);
}
const getActiveChart = (sheet) => {
let activeChart = null;
sheet.charts.all().forEach(function (chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet />
</SpreadSheets>
</div>
<Panel applySetting={(e) => { applySetting(e) }} setting={hoverInfo} />
</div>);
}
function Panel(props) {
const [setting, setSetting] = React.useState(props.setting);
React.useEffect(() => {
if (props.setting !== setting) {
setSetting(props.setting);
}
}, [props.setting]);
return (
<div class="options-container">
<div class="option-row">
<label for="useAnimation">useAnimation</label>
<input type="checkbox" id="useAnimation" checked={setting.useAnimation} onClick={(e) => setSetting({ ...setting, useAnimation: _getBoolean(e) })} />
</div>
<div class="option-row" id="">
<label for="color">Color:</label>
<input type="text" id="color" value={setting.color} onChange={(e) => setSetting({ ...setting, color: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="transparency">Transparency:</label>
<input type="number" id="transparency" step="0.1" min="0" max="1" value={setting.transparency} onChange={(e) => setSetting({ ...setting, transparency: _getFloat(e) })} />
</div>
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" value={setting.borderColor} onChange={(e) => setSetting({ ...setting, borderColor: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" value={setting.borderWidth} onChange={(e) => setSetting({ ...setting, borderWidth: _getValue(e) })} />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" value={setting.borderTransparency} onChange={(e) => setSetting({ ...setting, borderTransparency: _getFloat(e) })} />
</div>
<div class="option-row" id="">
<label for="border-dashStyle">Border DashStyle:</label>
<select id="border-dashStyle" value={setting.borderDashStyle} onChange={(e) => setSetting({ ...setting, borderDashStyle: _getValue(e) })}>
<option value="0" selected="selected">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<hr />
<div class="option-row" id="">
<label for="symbol-color">Symbol Color:</label>
<input type="text" id="symbol-color" value={setting.symbolColor} onChange={(e) => setSetting({ ...setting, symbolColor: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="symbol-transparency">Symbol Transparency:</label>
<input type="number" id="symbol-transparency" step="0.1" min="0" max="1" value={setting.symbolTransparency} onChange={(e) => setSetting({ ...setting, symbolTransparency: _getFloat(e) })} />
</div>
<div class="option-row" id="">
<label for="symbol-border-color">Symbol Border Color:</label>
<input type="text" id="symbol-border-color" value={setting.symbolBorderColor} onChange={(e) => setSetting({ ...setting, symbolBorderColor: _getText(e) })} />
</div>
<div class="option-row" id="">
<label for="symbol-border-width">Symbol Border Width:</label>
<input type="number" id="symbol-border-width" step="1" min="0" max="100" value={setting.symbolBorderWidth} onChange={(e) => setSetting({ ...setting, symbolBorderWidth: _getValue(e) })} />
</div>
<div class="option-row" id="">
<label for="symbol-border-transparency">Symbol Border Transparency:</label>
<input type="number" id="symbol-border-transparency" step="0.1" min="0" max="1" value={setting.symbolBorderTransparency} onChange={(e) => setSetting({ ...setting, symbolBorderTransparency: _getFloat(e) })} />
</div>
<div class="option-row" id="">
<label for="symbol-border-dashStyle">Symbol Border DashStyle:</label>
<select id="symbol-border-dashStyle" value={setting.symbolBorderDashStyle} onChange={(e) => setSetting({ ...setting, symbolBorderDashStyle: _getValue(e) })}>
<option value="0">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" onClick={(e) => { props.applySetting(setting) }} />
</div>
</div>
)
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
const Component = React.Component;
function _getBoolean (e) {
return e.target.checked;
}
function _getFloat(e) {
return parseFloat(e.target.value);
}
function _getValue(e) {
return parseInt(e.target.value);
}
function _getText(e) {
return e.target.value;
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
useAnimation: true,
color: "#FF0000",
transparency: 0.7,
borderColor: "#00FF00",
borderWidth: 1,
borderTransparency: 1,
borderDashStyle: "0",
symbolColor: "orange",
symbolTransparency: 0.7,
symbolBorderColor: "rgb(255,0,255)",
symbolBorderWidth: 1,
symbolBorderTransparency: 0.7,
symbolBorderDashStyle: "0"
}
}
render() {
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet />
</SpreadSheets>
</div>
<Panel applySetting={(e) => { this.applySetting(e) }} setting= {this.state}/>
</div>);
}
initSpread(spread) {
this.spread = spread;
spread.setSheetCount(2);
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
let chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 494, 0, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({ text: "HoverStyle with markers" });
let seriesItem = chart.series().get(0);
seriesItem.symbol.size = 20;
chart.series().set(0, seriesItem);
let hoverStyle = {
color: "orange",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 3,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
},
symbolStyle: {
color: "yellow",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: 'rgb(0, 0, 255)',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
}
};
chart.hoverStyle(hoverStyle);
let chart2 = sheet.charts.add('Chart2', GC.Spread.Sheets.Charts.ChartType.columnClustered, 0, 100, 494, 275, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart2.title({ text: "Default HoverStyle" });
let chart3 = sheet.charts.add('Chart3', GC.Spread.Sheets.Charts.ChartType.pie, 494, 270, 480, 270, 'A1:H2');
chart3.title({ text: "HoverStyle with Animation" });
chart3.useAnimation(true);
let hoverStyle3 = {
color: "orange",
transparency: 0.6,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
};
chart3.hoverStyle(hoverStyle3);
this.initEvent(spread);
this.readSetting(chart);
sheet.resumePaint();
};
initEvent() {
let self = this;
self.spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, function () {
let sheet = self.spread.getActiveSheet();
let chart = self.getActiveChart(sheet);
if (chart) {
self.readSetting(chart);
}
});
};
readSetting(chart) {
let useAnimation = chart.useAnimation();
let hoverStyle = chart.hoverStyle();
if (!hoverStyle) {
return;
}
this.setState({
useAnimation: useAnimation,
color: hoverStyle.color || "",
transparency: hoverStyle.transparency,
borderColor: hoverStyle.borderStyle.color || "",
borderWidth: hoverStyle.borderStyle.width || 0,
borderTransparency: hoverStyle.borderStyle.transparency,
borderDashStyle: hoverStyle.borderStyle.dashStyle,
symbolColor: hoverStyle.symbolStyle.color || "",
symbolTransparency: hoverStyle.symbolStyle.transparency,
symbolBorderColor: hoverStyle.symbolStyle.borderStyle.color || "",
symbolBorderWidth: hoverStyle.symbolStyle.borderStyle.width || 0,
symbolBorderTransparency: hoverStyle.symbolStyle.borderStyle.transparency,
symbolBorderDashStyle: hoverStyle.symbolStyle.borderStyle.dashStyle,
})
}
applySetting(setting) {
let sheet = this.spread.getActiveSheet();
let chart = this.getActiveChart(sheet);
if (!chart) {
return;
}
chart.useAnimation(setting.useAnimation);
let hoverStyle = {
color: setting.color,
transparency: setting.transparency,
borderStyle: {
color: setting.borderColor,
width: setting.borderWidth,
transparency: setting.borderTransparency,
dashStyle: setting.borderDashStyle,
},
symbolStyle: {
color: setting.symbolColor,
transparency: setting.symbolTransparency,
borderStyle: {
color: setting.symbolBorderColor,
width: setting.symbolBorderWidth,
transparency: setting.symbolBorderTransparency,
dashStyle: setting.symbolBorderDashStyle,
}
}
}
chart.hoverStyle(hoverStyle);
}
getActiveChart(sheet) {
let activeChart = null;
sheet.charts.all().forEach(function (chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
}
class Panel extends Component {
constructor(props) {
super(props);
this.state = this.props.setting;
}
componentWillReceiveProps(nextProps) {
this.setState(nextProps.setting);
}
render() {
return (
<div class="options-container">
<div class="option-row">
<label for="useAnimation">useAnimation</label>
<input type="checkbox" id="useAnimation" checked={this.state.useAnimation} onClick={(e) =>this.setState({useAnimation: _getBoolean(e)})} />
</div>
<div class="option-row" id="">
<label for="color">Color:</label>
<input type="text" id="color" value={this.state.color} onChange={(e) =>this.setState({color: _getText(e)})} />
</div>
<div class="option-row" id="">
<label for="transparency">Transparency:</label>
<input type="number" id="transparency" step="0.1" min="0" max="1" value={this.state.transparency} onChange={(e) =>this.setState({transparency: _getFloat(e)})} />
</div>
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" value={this.state.borderColor} onChange={(e) =>this.setState({borderColor: _getText(e)})}/>
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" value={this.state.borderWidth} onChange={(e) =>this.setState({borderWidth: _getValue(e)})} />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" value={this.state.borderTransparency} onChange={(e) =>this.setState({borderTransparency: _getFloat(e)})} />
</div>
<div class="option-row" id="">
<label for="border-dashStyle">Border DashStyle:</label>
<select id="border-dashStyle" value={this.state.borderDashStyle} onChange={(e) =>this.setState({borderDashStyle: _getValue(e)})}>
<option value="0" selected="selected">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<hr/>
<div class="option-row" id="">
<label for="symbol-color">Symbol Color:</label>
<input type="text" id="symbol-color" value={this.state.symbolColor} onChange={(e) =>this.setState({symbolColor: _getText(e)})}/>
</div>
<div class="option-row" id="">
<label for="symbol-transparency">Symbol Transparency:</label>
<input type="number" id="symbol-transparency" step="0.1" min="0" max="1" value={this.state.symbolTransparency} onChange={(e) =>this.setState({symbolTransparency: _getFloat(e)})} />
</div>
<div class="option-row" id="">
<label for="symbol-border-color">Symbol Border Color:</label>
<input type="text" id="symbol-border-color" value={this.state.symbolBorderColor} onChange={(e) =>this.setState({symbolBorderColor: _getText(e)})} />
</div>
<div class="option-row" id="">
<label for="symbol-border-width">Symbol Border Width:</label>
<input type="number" id="symbol-border-width" step="1" min="0" max="100" value={this.state.symbolBorderWidth} onChange={(e) =>this.setState({symbolBorderWidth: _getValue(e)})} />
</div>
<div class="option-row" id="">
<label for="symbol-border-transparency">Symbol Border Transparency:</label>
<input type="number" id="symbol-border-transparency" step="0.1" min="0" max="1" value={this.state.symbolBorderTransparency} onChange={(e) =>this.setState({symbolBorderTransparency: _getFloat(e)})} />
</div>
<div class="option-row" id="">
<label for="symbol-border-dashStyle">Symbol Border DashStyle:</label>
<select id="symbol-border-dashStyle" value={this.state.symbolBorderDashStyle} onChange={(e) =>this.setState({symbolBorderDashStyle: _getValue(e)})}>
<option value="0">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" onClick={(e)=>{this.props.applySetting(this.state)}}/>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display:inline-block;
}
input{
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select{
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Hover Style: SpreadJS supports the following hover style customizations:
the color and transparency
Border: color, transparency, width, dash style
Symbol: color, transparency
Symbol Border: color, transparency, width, dash style
You can customize the hover style using the following code:
Hover Animation: Hover animation can help to improve the user experience when interacting with the chart. You can use the useAnimation() API to set whether or not to apply animation to the chart.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import '@mescius/spread-sheets-charts';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
useAnimation = true;
color = "#FF0000";
transparency = 0.7;
borderColor = "#00FF00";
borderWidth = 1;
borderTransparency = 1;
borderDashStyle = "0";
symbolColor = "orange";
symbolTransparency = 0.7;
symbolBorderColor = "rgb(255,0,255)";
symbolBorderWidth = 1;
symbolBorderTransparency = 0.7;
symbolBorderDashStyle = "0";
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
let dataArray = [
["", 'Chrome', 'Firefox', 'IE', 'Safari', 'Edge', 'Opera', 'Other'],
["2014", 0.4966, 0.1801, 0.2455, 0.0470, 0.0, 0.0150, 0.0158],
["2015", 0.5689, 0.1560, 0.1652, 0.0529, 0.0158, 0.0220, 0.0192],
["2016", 0.6230, 0.1531, 0.1073, 0.0464, 0.0311, 0.0166, 0.0225],
["2017", 0.6360, 0.1304, 0.0834, 0.0589, 0.0443, 0.0223, 0.0246]
];
sheet.setArray(0, 0, dataArray);
let chart = sheet.charts.add('Chart1', GC.Spread.Sheets.Charts.ChartType.lineMarkers, 494, 0, 480, 270, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart.title({
text: "HoverStyle with markers"
});
let seriesItem = chart.series().get(0);
seriesItem.symbol.size = 20;
chart.series().set(0, seriesItem);
let hoverStyle = {
color: "orange",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 3,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
},
symbolStyle: {
color: "yellow",
transparency: 0.1,
borderStyle: {
transparency: 0.1,
color: 'rgb(0, 0, 255)',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
}
};
chart.hoverStyle(hoverStyle);
let chart2 = sheet.charts.add('Chart2', GC.Spread.Sheets.Charts.ChartType.columnClustered, 0, 100, 494, 275, "A1:D5", GC.Spread.Sheets.Charts.RowCol.columns);
chart2.title({
text: "Default HoverStyle"
});
let chart3 = sheet.charts.add('Chart3', GC.Spread.Sheets.Charts.ChartType.pie, 494, 270, 480, 270, 'A1:H2');
chart3.title({
text: "HoverStyle with Animation"
});
chart3.useAnimation(true);
let hoverStyle3 = {
color: "orange",
transparency: 0.6,
borderStyle: {
transparency: 0.1,
color: '#FF0000',
width: 9,
dashStyle: GC.Spread.Sheets.Charts.LineType.lgDash
}
};
chart3.hoverStyle(hoverStyle3);
this.initEvent();
this.readSetting(chart);
sheet.resumePaint();
}
initEvent() {
let self = this;
self.spread.bind(GC.Spread.Sheets.Events.FloatingElementSelected, function() {
let sheet = self.spread.getActiveSheet();
let chart = self.getActiveChart(sheet);
if (chart) {
self.readSetting(chart);
}
});
}
readSetting(chart: GC.Spread.Sheets.Charts.Chart) {
let useAnimation = chart.useAnimation();
let hoverStyle = chart.hoverStyle();
if (!hoverStyle) {
return;
}
this.useAnimation = useAnimation;
this.color = hoverStyle.color;
this.transparency = hoverStyle.transparency;
this.borderColor = hoverStyle.borderStyle.color;
this.borderWidth = hoverStyle.borderStyle.width;
this.borderTransparency = hoverStyle.borderStyle.transparency;
this.borderDashStyle = hoverStyle.borderStyle.dashStyle;
this.symbolColor = hoverStyle.symbolStyle.color;
this.symbolTransparency = hoverStyle.symbolStyle.transparency;
this.symbolBorderColor = hoverStyle.symbolStyle.borderStyle.color;
this.symbolBorderWidth = hoverStyle.symbolStyle.borderStyle.width;
this.symbolBorderTransparency = hoverStyle.symbolStyle.borderStyle.transparency;
this.symbolBorderDashStyle = hoverStyle.symbolStyle.borderStyle.dashStyle;
}
applySetting() {
let sheet = this.spread.getActiveSheet();
let chart = this.getActiveChart(sheet);
if (!chart) {
return;
}
chart.useAnimation(this.useAnimation);
let hoverStyle = {
color: this.color,
transparency: parseFloat(<any>this.transparency),
borderStyle: {
color: this.borderColor,
width: parseInt(<any>this.borderWidth),
transparency: parseFloat(<any>this.borderTransparency),
dashStyle: parseInt(this.borderDashStyle),
},
symbolStyle: {
color: this.symbolColor,
transparency: parseFloat(<any>this.symbolTransparency),
borderStyle: {
color: this.symbolBorderColor,
width: parseInt(<any>this.symbolBorderWidth),
transparency: parseFloat(<any>this.symbolBorderTransparency),
dashStyle: parseInt(this.symbolBorderDashStyle),
}
}
}
chart.hoverStyle(hoverStyle);
}
getActiveChart(sheet: GC.Spread.Sheets.Worksheet): GC.Spread.Sheets.Charts.Chart | null {
let activeChart = null;
sheet.charts.all().forEach(function(chart: GC.Spread.Sheets.Charts.Chart) {
if (chart.isSelected()) {
activeChart = chart;
}
});
return activeChart;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label for="useAnimation">useAnimation</label>
<input type="checkbox" id="useAnimation" [(ngModel)]="useAnimation" />
</div>
<div class="option-row" id="">
<label for="color">Color:</label>
<input type="text" id="color" [(ngModel)]="color" />
</div>
<div class="option-row" id="">
<label for="transparency">Transparency:</label>
<input type="number" id="transparency" step="0.1" min="0" max="1" [(ngModel)]="transparency" />
</div>
<div class="option-row" id="">
<label for="border-color">Border Color:</label>
<input type="text" id="border-color" [(ngModel)]="borderColor" />
</div>
<div class="option-row" id="">
<label for="border-width">Border Width:</label>
<input type="number" id="border-width" step="1" min="0" max="100" [(ngModel)]="borderWidth" />
</div>
<div class="option-row" id="">
<label for="border-transparency">Border Transparency:</label>
<input type="number" id="border-transparency" step="0.1" min="0" max="1" [(ngModel)]="borderTransparency" />
</div>
<div class="option-row" id="">
<label for="border-dashStyle">Border DashStyle:</label>
<select id="border-dashStyle" [(ngModel)]="borderDashStyle">
<option value="0">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<hr>
<div class="option-row" id="">
<label for="symbol-color">Symbol Color:</label>
<input type="text" id="symbol-color" [(ngModel)]="symbolColor" />
</div>
<div class="option-row" id="">
<label for="symbol-transparency">Symbol Transparency:</label>
<input type="number" id="symbol-transparency" step="0.1" min="0" max="1" [(ngModel)]="symbolTransparency" />
</div>
<div class="option-row" id="">
<label for="symbol-border-color">Symbol Border Color:</label>
<input type="text" id="symbol-border-color" [(ngModel)]="symbolBorderColor" />
</div>
<div class="option-row" id="">
<label for="symbol-border-width">Symbol Border Width:</label>
<input type="number" id="symbol-border-width" step="1" min="0" max="100" [(ngModel)]="symbolBorderWidth" />
</div>
<div class="option-row" id="">
<label for="symbol-border-transparency">Symbol Border Transparency:</label>
<input type="number" id="symbol-border-transparency" step="0.1" min="0" max="1" [(ngModel)]="symbolBorderTransparency" />
</div>
<div class="option-row" id="">
<label for="symbol-border-dashStyle">Symbol Border DashStyle:</label>
<select id="symbol-border-dashStyle" [(ngModel)]="symbolBorderDashStyle">
<option value="0">solid</option>
<option value="1">dot</option>
<option value="2">dash</option>
<option value="3">lgDash</option>
<option value="4">dashDot</option>
<option value="5">lgDashDot</option>
<option value="6">lgDashDotDot</option>
<option value="7">sysDash</option>
<option value="8">sysDot</option>
<option value="9">sysDashDot</option>
<option value="10">sysDashDotDot</option>
</select>
</div>
<div class="option-row">
<input type="button" id="apply" value="Set" (click)="applySetting()" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
}
.option-row {
padding-bottom: 5px;
}
label {
display:inline-block;
}
input{
padding: 1px 8px;
box-sizing: border-box;
width: 100%;
}
select{
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);